
package org.mule.module.magento.config;

import java.util.List;
import org.apache.commons.lang.StringUtils;
import org.mule.config.spring.MuleHierarchicalBeanDefinitionParserDelegate;
import org.mule.config.spring.util.SpringXMLUtils;
import org.mule.module.magento.processors.GetCategoryMessageProcessor;
import org.mule.util.TemplateParser;
import org.springframework.beans.MutablePropertyValues;
import org.springframework.beans.PropertyValue;
import org.springframework.beans.factory.config.BeanDefinition;
import org.springframework.beans.factory.config.RuntimeBeanReference;
import org.springframework.beans.factory.support.BeanDefinitionBuilder;
import org.springframework.beans.factory.support.ManagedList;
import org.springframework.beans.factory.xml.BeanDefinitionParser;
import org.springframework.beans.factory.xml.ParserContext;
import org.springframework.util.xml.DomUtils;
import org.w3c.dom.Element;

public class GetCategoryDefinitionParser
    implements BeanDefinitionParser
{

    /**
     * Mule Pattern Info
     * 
     */
    private TemplateParser.PatternInfo patternInfo;

    public GetCategoryDefinitionParser() {
        patternInfo = TemplateParser.createMuleStyleParser().getStyle();
    }

    public BeanDefinition parse(Element element, ParserContext parserContent) {
        BeanDefinitionBuilder builder = BeanDefinitionBuilder.rootBeanDefinition(GetCategoryMessageProcessor.class.getName());
        String configRef = element.getAttribute("config-ref");
        if ((configRef!= null)&&(!StringUtils.isBlank(configRef))) {
            builder.addPropertyValue("moduleObject", configRef);
        }
        if ((element.getAttribute("categoryId")!= null)&&(!StringUtils.isBlank(element.getAttribute("categoryId")))) {
            builder.addPropertyValue("categoryId", element.getAttribute("categoryId"));
        }
        if ((element.getAttribute("storeViewIdOrCode")!= null)&&(!StringUtils.isBlank(element.getAttribute("storeViewIdOrCode")))) {
            builder.addPropertyValue("storeViewIdOrCode", element.getAttribute("storeViewIdOrCode"));
        }
        Element attributeNamesListElement = null;
        attributeNamesListElement = DomUtils.getChildElementByTagName(element, "attribute-names");
        List<Element> attributeNamesListChilds = null;
        if (attributeNamesListElement!= null) {
            String attributeNamesRef = attributeNamesListElement.getAttribute("ref");
            if ((attributeNamesRef!= null)&&(!StringUtils.isBlank(attributeNamesRef))) {
                if ((!attributeNamesRef.startsWith(patternInfo.getPrefix()))&&(!attributeNamesRef.endsWith(patternInfo.getSuffix()))) {
                    builder.addPropertyValue("attributeNames", new RuntimeBeanReference(attributeNamesRef));
                } else {
                    builder.addPropertyValue("attributeNames", attributeNamesRef);
                }
            } else {
                ManagedList attributeNames = new ManagedList();
                attributeNamesListChilds = DomUtils.getChildElementsByTagName(attributeNamesListElement, "attribute-name");
                if (attributeNamesListChilds!= null) {
                    for (Element attributeNamesChild: attributeNamesListChilds) {
                        String valueRef = attributeNamesChild.getAttribute("value-ref");
                        if ((valueRef!= null)&&(!StringUtils.isBlank(valueRef))) {
                            if ((!valueRef.startsWith(patternInfo.getPrefix()))&&(!valueRef.endsWith(patternInfo.getSuffix()))) {
                                attributeNames.add(new RuntimeBeanReference(valueRef));
                            } else {
                                attributeNames.add(valueRef);
                            }
                        } else {
                            attributeNames.add(attributeNamesChild.getTextContent());
                        }
                    }
                }
                builder.addPropertyValue("attributeNames", attributeNames);
            }
        }
        BeanDefinition definition = builder.getBeanDefinition();
        definition.setAttribute(MuleHierarchicalBeanDefinitionParserDelegate.MULE_NO_RECURSE, Boolean.TRUE);
        MutablePropertyValues propertyValues = parserContent.getContainingBeanDefinition().getPropertyValues();
        if (parserContent.getContainingBeanDefinition().getBeanClassName().equals("org.mule.config.spring.factories.PollingMessageSourceFactoryBean")) {
            propertyValues.addPropertyValue("messageProcessor", definition);
        } else {
            if (parserContent.getContainingBeanDefinition().getBeanClassName().equals("org.mule.enricher.MessageEnricher")) {
                propertyValues.addPropertyValue("enrichmentMessageProcessor", definition);
            } else {
                PropertyValue messageProcessors = propertyValues.getPropertyValue("messageProcessors");
                if ((messageProcessors == null)||(messageProcessors.getValue() == null)) {
                    propertyValues.addPropertyValue("messageProcessors", new ManagedList());
                }
                List listMessageProcessors = ((List) propertyValues.getPropertyValue("messageProcessors").getValue());
                listMessageProcessors.add(definition);
            }
        }
        return definition;
    }

    protected String getAttributeValue(Element element, String attributeName) {
        if (!StringUtils.isEmpty(element.getAttribute(attributeName))) {
            return element.getAttribute(attributeName);
        }
        return null;
    }

    private String generateChildBeanName(Element element) {
        String id = SpringXMLUtils.getNameOrId(element);
        if (StringUtils.isBlank(id)) {
            String parentId = SpringXMLUtils.getNameOrId(((Element) element.getParentNode()));
            return ((("."+ parentId)+":")+ element.getLocalName());
        } else {
            return id;
        }
    }

}
